SystemOrganization addCategory: #'Smutty-Tests'!

TestCase subclass: #DialogNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!DialogNodeTest commentStamp: '<historical>' prior: 0!
A DialogNodeTest is a test class for testing the behavior of DialogNode!

!DialogNodeTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/23/2015 05:42'!
test_01_equality

	| node1 node2 |
	node1 := DialogNode description: 'Hi!!'.
	node2 := DialogNode description: 'Hi!!'.
	self assert: node1 equals: node2.! !

TestCase subclass: #FinishDialogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!FinishDialogTest commentStamp: '<historical>' prior: 0!
A FinishDialogTest is a test class for testing the behavior of FinishDialog!

!FinishDialogTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 10/27/2015 18:14'!
test_01_redefineForGame
	| action |

	action := FinishDialog new.
	action game: 1.
	action redefineForGame: 2.
	self assert: action game = 2.! !

TestCase subclass: #GameStateGraphBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!GameStateGraphBuilderTest commentStamp: '<historical>' prior: 0!
A GameStateGraphBuilderTest is a test class for testing the behavior of GameStateGraphBuilder!

!GameStateGraphBuilderTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/11/2015 06:40'!
test_01_buildingTwoNodes

	| graph initialNode secondNode |
	graph := GameStateGraphBuilder graphFrom: (SJTGameController on: SJTGame twoLocationsExample).
	self assert: graph nodesSize = 2.
	initialNode := graph initialNode.
	secondNode  := (graph nodes detect: [:each | each ~= initialNode]).
	self deny: initialNode = secondNode.
	self assert: (graph transitionsFrom: initialNode) size = 1.
	self assert: (graph transitionsFrom: secondNode) size = 1.! !

!GameStateGraphBuilderTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/11/2015 07:38'!
test_02_buildingFirstTownExample

	| graph firstNode |
	graph := GameStateGraphBuilder graphFrom: (SJTGameController on: SJTGame firstTownExample).
	self assert: graph nodesSize = 11.
	firstNode := graph initialNode.
	self assert: firstNode location neighbours size = 3.
	self assert: (graph transitionsFrom: firstNode) size = 3.! !

!GameStateGraphBuilderTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/22/2015 07:25'!
test_03_buildingSingleLocationWithNPC

	| graph initialNode secondNode |
	graph := GameStateGraphBuilder graphFrom: (SJTGameController on: SJTGame singleLocationWithNPCExample).
	self assert: graph nodesSize = 2.
	initialNode := graph initialNode.
	secondNode  := (graph nodes detect: [:each | each ~= initialNode]).
	self deny: initialNode = secondNode.
	self assert: (graph transitionsFrom: initialNode) size = 1.
	self assert: (graph transitionsFrom: secondNode) size = 1.! !

!GameStateGraphBuilderTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 9/23/2015 04:59'!
test_04_buildingTwoLocationsWithNPCExample

	| graph initialNode secondNode |
	graph := GameStateGraphBuilder graphFrom: (SJTGameController on: SJTGame twoLocationsWithNPCExample).
	self assert: graph nodesSize = 5.
	initialNode := graph initialNode.
	secondNode  := (graph transitionsFrom: initialNode) first destination.
	self deny: initialNode = secondNode.
	self assert: (graph transitionsFrom: initialNode) size = 1.
	self assert: (graph transitionsFrom: secondNode) size = 2.! !

TestCase subclass: #LocationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!LocationTest commentStamp: '<historical>' prior: 0!
A LocationTest is a test class for testing the behavior of Location!

!LocationTest methodsFor: 'tests' stamp: 'SergioFedi 8/28/2015 23:07'!
test_01_defaultValues

	| newLocation |
	newLocation := Location new.
	self assert: newLocation name = 'New location'.
	self assert: newLocation description = ''.
	self assert: newLocation neighbours isEmpty.
	! !

!LocationTest methodsFor: 'tests' stamp: 'SergioFedi 9/1/2015 16:17'!
test_01_equality

	| location1 location2 |
	location1 := Location new.
	location2 := Location new.
	self assert: location1 = location2.
	! !

TestCase subclass: #NPCTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!NPCTest commentStamp: '<historical>' prior: 0!
A NPCTest is a test class for testing the behavior of NPC!

!NPCTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:29'!
test_01_defaultValues

	| npc |
	npc := NPC new.
	self assert: npc dialog isNil.
	self assert: npc name = 'Unnamed'.! !

!NPCTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:30'!
test_02_minimalNPC

	| npc |
	npc := NPC lonelyNPC.
	self assert: npc name = 'Lonely NPC'.
	self assert: npc dialog notNil.
	self assert: npc dialog description = 'I''m just a lonely NPC'.
	self assert: npc dialog options isEmpty.! !

!NPCTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:31'!
test_03_typicalNPC

	| npc dialogOption1 dialogOption2 |
	npc := NPC lonelyChattyNPC.
	self assert: npc name = 'Lonely NPC'.
	self assert: npc dialog notNil.
	self assert: npc dialog description = 'I''m just a lonely NPC'.
	self assert: npc dialog options size = 2.
	self assert: npc dialog options first description = 'Do you want to talk?'.
	self assert: npc dialog options second description = 'Are you lonely?'.
	dialogOption1 := npc dialog options first.
	self assert: dialogOption1 node description = 'No'.
	self assert: dialogOption1 node options isEmpty.
	dialogOption2 := npc dialog options second.
	self assert: dialogOption2 node description = 'Yes'.
	self assert: dialogOption2 node options isEmpty.
	! !

TestCase subclass: #QuestStateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!QuestStateTest commentStamp: '<historical>' prior: 0!
A QuestStateTest is a test class for testing the behavior of QuestState!

!QuestStateTest methodsFor: 'tests' stamp: 'FedericoFigueredo 6/3/2015 07:41'!
test_01_advancingTheQuest
	| quest questState questAdvancer action |
	
	quest := StoryMap example.
	questState := QuestState on: quest.
	questAdvancer := QuestAdvancer new.
	action := QuestAction description: 'Win!!'.
	
	self assert: questState currentNode = quest nodes first.
	questAdvancer advance: questState with: action.
	self assert: questState currentNode = quest nodes last.! !

TestCase subclass: #SJTGameControllerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!SJTGameControllerTest commentStamp: '<historical>' prior: 0!
A SJTGameControllerTest is a test class for testing the behavior of SJTGameController!

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/11/2015 06:35'!
test_01_MovingToOnePlace

	| controller initialLocation finalLocation |
	controller := SJTGameController on: SJTGame twoLocationsExample.
	initialLocation := controller location.
	self assert: controller options size = 1.
	controller choose: controller options first.
	finalLocation := controller location.
	self deny: finalLocation = initialLocation.! !

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/11/2015 06:35'!
test_02_MovingBack

	| controller initialLocation finalLocation |
	controller := SJTGameController on: SJTGame twoLocationsExample.
	initialLocation := controller location.
	controller choose: controller options first.
	self assert: controller options size = 1.
	controller choose: controller options first.
	finalLocation := controller location.
	self assert: finalLocation = initialLocation.! !

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/11/2015 07:01'!
test_03_OptionsEqualNeighbours

	| controller initialLocation  |
	controller := SJTGameController on: SJTGame firstTownExample.
	initialLocation := controller location.
	self assert: initialLocation neighbours size = 3.
	self assert: controller options size = 3.
! !

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:03'!
test_04_NoOptionsForMoving

	| controller initialLocation  |
	controller := SJTGameController on: SJTGame singleLocationExample.
	initialLocation := controller location.
	self assert: controller options isEmpty.
	self assert: initialLocation notNil.
! !

!SJTGameControllerTest methodsFor: 'tests' stamp: 'SergioFedi 9/24/2015 06:07'!
test_05_CanTalkWithNPC

	| controller initialLocation  |
	controller := SJTGameController on: SJTGame singleLocationWithNPCExample.
	initialLocation := controller location.
	self assert: controller options size = 1.
	self assert: initialLocation notNil.
! !

TestCase subclass: #SJTGameStateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!SJTGameStateTest commentStamp: '<historical>' prior: 0!
A SJTGameStateTest is a test class for testing the behavior of SJTGameState!

!SJTGameStateTest methodsFor: 'tests' stamp: 'SergioFedi 9/23/2015 05:43'!
test_01_equality

	| state1 state2 |
	state1 := SJTGameState location: 1 version: 'pling' dialog: (DialogNode description: 'Hola').
	state2 := SJTGameState location: 1 version: 'pling' dialog: (DialogNode description: 'Hola').
	self assert: state1 = state2.! !

!SJTGameStateTest methodsFor: 'tests' stamp: 'SergioFedi 9/1/2015 16:30'!
test_02_equality2

	| state1 state2 |
	state1 := SJTGame singleLocationExample state.
	state2 := SJTGame twoLocationsExample state.
	self deny: state1 = state2.! !

!SJTGameStateTest methodsFor: 'tests' stamp: 'SergioFedi 9/23/2015 05:51'!
test_03_equality3

	| state1 state2 |
	state1 := SJTGameState location: 1 version: 'pling' dialog: (DialogNode description: 'Hola').
	state2 := SJTGameState location: 1 version: 'pling' dialog: (DialogNode description: 'Chau').
	self deny: state1 = state2.! !

TestCase subclass: #SJTGameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!SJTGameTest commentStamp: '<historical>' prior: 0!
A SJTGameTest is a test class for testing the behavior of SJTGame!

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/2/2015 06:31'!
test_01_creation

	| newSJTGame |
	newSJTGame := SJTGame new.
	self assert: newSJTGame locations isEmpty.
	self assert: newSJTGame playerCharacter isNil.
	self assert: newSJTGame version = 'new'.! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/4/2015 23:03'!
test_02_validityOfNewInstance

	| newSJTGame |
	newSJTGame := SJTGame new.
	self deny: newSJTGame isValid.
	self assert: SJTGame singleLocationExample isValid.
	self assert: SJTGame twoLocationsExample isValid.
	self assert: SJTGame firstTownExample isValid.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/7/2015 07:24'!
test_03_fromMemento

	| anSJTGame memento newSJTGame |
	anSJTGame := SJTGame singleLocationExample.
	memento := anSJTGame state.
	newSJTGame := SJTGame fromMemento: memento.
	self assert: anSJTGame locations size = newSJTGame locations size.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/9/2015 07:26'!
test_04_fromMementoPlayerLocation

	| anSJTGame memento newSJTGame originalLocation |
	anSJTGame := SJTGame twoLocationsExample.
	originalLocation := anSJTGame playerCharacter location.
	anSJTGame optionsForPlayerCharacterMovingToNeighbours first perform.
	memento := anSJTGame state.
	newSJTGame := SJTGame fromMemento: memento.
	self deny: originalLocation = newSJTGame playerCharacter location.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/23/2015 05:26'!
test_05_validityOfFirstTownExample

	| example |
	example := SJTGame firstTownExample.
	self assert: example locations size = 11.
	self assert: example playerCharacter location neighbours size = 3.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/22/2015 07:19'!
test_06_newInstanceAndNPCs

	| newSJTGame |
	newSJTGame := SJTGame new.
	self assert: SJTGame singleLocationExample locations first npcs isEmpty.
	self assert: SJTGame twoLocationsExample locations first npcs isEmpty.
	self assert: SJTGame twoLocationsExample locations second npcs isEmpty.
	self assert: SJTGame singleLocationWithNPCExample locations first npcs notEmpty.
	self deny: SJTGame singleLocationWithNPCExample version = 'singleLocationExample'.
	self assert: SJTGame twoLocationsWithNPCExample locations first npcs isEmpty.
	self assert: SJTGame twoLocationsWithNPCExample locations second npcs notEmpty.
	self assert: SJTGame twoLocationsWithNPCExample version = 'twoLocationsWithNPCExample'.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/16/2015 07:50'!
test_07_optionsForSingleLocationExample

	| game |
	game := SJTGame singleLocationExample.
	self assert: game optionsForPlayerCharacter isEmpty.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs isEmpty.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/22/2015 07:44'!
test_08_optionsForSingleLocationWithNPCExample

	| game |
	game := SJTGame singleLocationWithNPCExample.
	self assert: game optionsForPlayerCharacter size = 1.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 1.
	self deny: game playerCharacter isInDialog.
	game optionsForPlayerCharacter first perform.
	self assert: game optionsForPlayerCharacter size = 1.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 1.
	self assert: game playerCharacter isInDialog.
	game optionsForPlayerCharacter first perform.
	self assert: game optionsForPlayerCharacter size = 1.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 1.
	self deny: game playerCharacter isInDialog.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/22/2015 07:41'!
test_09_optionsForTwoLocationsWithNPCExample

	| game |
	game := SJTGame twoLocationsWithNPCExample.
	self assert: game optionsForPlayerCharacter size = 1.
	self assert: game optionsForPlayerCharacterMovingToNeighbours size = 1.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs isEmpty.
	game optionsForPlayerCharacter first perform.
	self assert: game optionsForPlayerCharacter size = 2.
	self assert: game optionsForPlayerCharacterMovingToNeighbours size = 1.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 1.
	game optionsForPlayerCharacterInteractingWithNPCs first perform.
	self assert: game optionsForPlayerCharacter size = 2.
	self assert: game optionsForPlayerCharacterMovingToNeighbours isEmpty.
	self assert: game optionsForPlayerCharacterInteractingWithNPCs size = 2.
! !

!SJTGameTest methodsFor: 'tests' stamp: 'SergioFedi 9/23/2015 06:56'!
test_10_fromMementoInDialog

	| originalSJTGame memento newSJTGame |
	originalSJTGame := SJTGame singleLocationWithNPCExample.
	originalSJTGame optionsForPlayerCharacter first perform.
	memento := originalSJTGame state.
	newSJTGame := SJTGame fromMemento: memento.
	self assert: originalSJTGame locations size = newSJTGame locations size.
	self assert: originalSJTGame playerCharacter isInDialog.
	self assert: newSJTGame playerCharacter isInDialog.

! !

TestCase subclass: #StoryMapTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryMapTest commentStamp: '<historical>' prior: 0!
A StoryMapTest is a test class for testing the behavior of StoryMap!

!StoryMapTest methodsFor: 'tests' stamp: 'SergioFedi 6/5/2015 20:59'!
test_01_example

	| story |
	story := StoryMap example.
	self assert: story beginning notNil.
	self assert: story nodes notEmpty.
	self assert: story transitions notEmpty.! !

TestCase subclass: #StoryNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryNodeTest commentStamp: '<historical>' prior: 0!
A StoryNodeTest is a test class for testing the behavior of StoryNode!

!StoryNodeTest methodsFor: 'tests' stamp: 'SergioFedi 6/6/2015 00:17'!
test_01_creation

	| node |
	node := StoryNode new.
	self assert: node text isNil.
	node text: 'test'.
	self assert: node text = 'test'.! !

!StoryNodeTest methodsFor: 'tests' stamp: 'SergioFedi 6/18/2015 06:42'!
test_02_textParsing

	| node |
	node := StoryNode new.
	self assert: node text isNil.
	self assert: node paragraphs isNil.
	node text: 'Paragraph 1 should be followed by two line breaks.

Paragraph 2 is the following text'.

	self assert: node paragraphs size = 2.
	self assert: node paragraphs first = 'Paragraph 1 should be followed by two line breaks.'.
	self assert: node paragraphs second = 'Paragraph 2 is the following text'.! !

TestCase subclass: #StoryTransitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryTransitionTest commentStamp: '<historical>' prior: 0!
A StoryTransitionTest is a test class for testing the behavior of StoryTransition!

!StoryTransitionTest methodsFor: 'tests' stamp: 'FedericoFigueredo 6/3/2015 08:00'!
test_01_actionDescription
	| transition placeholderOrigin placeholderDestination |
	
	placeholderOrigin := nil.
	placeholderDestination := nil.
	transition := StoryTransition origin: placeholderOrigin destination: placeholderDestination actionDescription: 'Win!!'. 
	
	self assert: (transition actionDescription = 'Win!!').! !
